library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_signed.all;

entity operazione6v2 is
	port ( din : in std_logic_vector(15 downto 0);
	clk,start: in std_logic;
	ris: out std_logic_vector(15 downto 0);
	fine: out std_logic);
end operazione6v2;

architecture beh of operazione6v2 is
type stati is (idle,letd0,exe1,exe2,exe3);
signal s: stati;
signal op: std_logic_vector(1 downto 0);
signal d0,R: std_logic_vector(15 downto 0);
signal end0,enexe1,enexe2,enexe3: std_logic;
signal conta: integer range 0 to 2;
signal max: integer range 0 to 2;
signal ultimo: std_logic;

begin
	
 end0 <= '1' when s= letd0 else '0';
 enexe1 <= '1' when s= exe1 else '0';
 enexe2 <= '1' when s= exe2 else '0';
 enexe3 <= '1' when s= exe3 else '0';

	 
 process(op)
 begin
	 case op is
		 when "01" => max <= 1;
		 when "10" => max <= 2;
		 when others => max <= 0;
	 end case;
 end process;
 
 ultimo <= '1' when conta = max else '0';
	 
 process(clk)
 begin										
	 if clk'event and clk='0' then		  
		 case s is
			 when idle => if start = '1' then s <= letd0;
			              else s <= idle;
				 		  end if;
			 when letd0 => case op is 
				           when "00"| "11" => -- lr | sr
				              s <= exe1;
				 		   when "01" => --and
							  s <= exe2;
						   when "10" => --add
						      s <= exe3;
						   when others => s<=idle; 
			              end case;
			when exe2  =>  if ultimo= '1' then s <= idle;
			              else s <= exe2;
						  end if;
		    when exe3 =>  if ultimo='1' then s <= idle;
			              else s <= exe3;
						  end if;
		    when others => s <= idle;
		  end case;	  
		 end if;
		  end process;
		  
		  process(clk)
		  begin
			  if clk'event and clk='0' then
				  if start = '1' then op<= din(1 downto 0);
					                  conta<= 0;
				  end if;
				  
				  if end0 = '1' then d0 <= din;
					                 
				  end if;
				  
				  if enexe1 = '1' then
					  if op(0) = '0' then -- lr
						  R<= d0;
					  else  -- sr
						  Ris <= R;
					  end if;
				  end if;
				  
				  if enexe2 = '1' then  -- and
					  if ultimo='1' then R<= d0 and R;
					  else conta<=conta+1;
				      end if;		 
				  end if;
				  
				  if enexe3 = '1' then  -- add
					  if ultimo='1' then R<= d0 + R;
					  else conta<=conta+1;
				      end if;	 
				  end if;
				  if (enexe1 = '1' or enexe2='1' or enexe3= '1' )and ultimo='1' then fine <= '1';
				  else fine<='0';
				  end if;
		end if;
	end process;
	end beh;
	